﻿@model web_app_voice.ModelsDto.TagsDto.TagDetailDto
@{
    ViewData["Title"] = "Tags";
    Layout = "~/Views/Shared/_Layout.cshtml";
}
<div class="row">
    <div class="ibox" style="overflow:auto">
        <div class="ibox-title">
            <h2>Smart Tag: @Model.Instance</h2>
        </div>
        <div class="ibox-content">
            <div class="row row-eq-height">
                <div class="col-lg-2 col-xs-4">
                    @switch (Model.Type)
                    {
                        case 1:
                            <img src="~/images/bus.png" style="height:128px; width:128px" />
                            break;

                        case 2:
                            <img src="~/images/trolley.png" style="height:128px; width:128px" />
                            break;

                        case 3:
                            <img src="~/images/stop.png" style="height:128px; width:128px" />
                            break;
                        default:
                            <img src="~/images/placeholder.png" style="height:128px; width:128px" />
                            break;
                    }
                </div>
                <div class="col-lg-3" style="min-height:90px; margin-top:30px">
                    <div class="row" style="min-height:40px; margin-top:2px">
                        <div class="col-lg-3"><b>MAC:</b></div>
                        <div class="col-lg-9">@Model.Mac</div>
                    </div>
                    <div class="row" style="min-height:40px; margin-top:2px">
                        <div class="col-lg-3"><b>URL:</b></div>
                        <div class="col-lg-9"></div>
                    </div>
                </div>
                <div class="col-lg-3" style="min-height:90px; margin-top:30px">
                    <div class="row" style="min-height:40px; margin-top:2px">
                        <div class="col-lg-3"><b>Namespace:</b></div>
                        <div class="col-lg-9">@Model.Namespace</div>
                    </div>
                    <div class="row" style="min-height:40px; margin-top:2px">
                        <div class="col-lg-3"><b>Type:</b></div>
                        <div class="col-lg-9">@Model.Instance</div>
                    </div>
                </div>
                <div class="col-lg-3" style="min-height:90px; margin-top:30px">
                    <div class="row" style="min-height:40px; margin-top:2px">
                        <div class="col-lg-4"><b>Instance:</b></div>
                        <div class="col-lg-8">@Model.Instance</div>
                    </div>
                    <div class="row" style="min-height:40px; margin-top:2px">
                        <div class="col-lg-4"><b>Last Seen Date:</b></div>
                        <div class="col-lg-8 text-left">@Model.LastSeenDate.ToString("yyyy MM dd")</div>
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="form-group col-lg-1 col-md-3 col-sm-2 col-xs-12 pull-right">
                    <div class="row pull-right">
                        <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12 list-group-item-heading">
                            <label type="button" class="btn btn-outline btn-primary" style="margin-top:10px;" id="change_status">
                                @if (Model.IsActive)
                                {
                                    <span>Aktivuoti</span>
                                }
                                else
                                {
                                    <span>Aktivuoti</span>
                                }

                            </label>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div class="ibox-content">
            <div class="row">
                <div class="form-group col-lg-2 col-md-6 col-sm-6 col-xs-12">
                    <label for="date6"><span data-i18n="body.datefrom">Data nuo</span></label>
                    <div class="form-group" style="bottom:0px; position:relative">
                        <div class="input-group date" id="datetimepickerNuo">
                            @if (Model != null && Model.ChartStartDate != null)
                            {
                                <input type="text" onkeydown="return false" class="form-control" id="dateFrom" value="@Model.ChartStartDate" />
                            }
                            else
                            {
                                <input type="text" onkeydown="return false" class="form-control" data-date-end-date="new Date()" id="dateFrom" />
                            }
                            <span class="input-group-addon">
                                <span class="glyphicon glyphicon-calendar"></span>
                            </span>
                        </div>
                    </div>
                </div>
                <div class="form-group col-lg-2 col-md-6 col-sm-6 col-xs-12">
                    <label for="date6"><b>Data iki</b></label>
                    <div class="form-group">
                        <div class="input-group date" id="datetimepickerIki">
                            @if (Model != null && Model.ChartEndDate != null)
                            {
                                <input type="text" onkeydown="return false" class="form-control" id="dateTo" value="@Model.ChartEndDate" />
                            }
                            else
                            {
                                <input type="text" onkeydown="return false" class="form-control" data-date-start-date="new Date()" id="dateTo" />
                            }
                            <span class="input-group-addon">
                                <span class="glyphicon glyphicon-calendar"></span>
                            </span>
                        </div>
                    </div>
                </div>
                <div class="form-group col-lg-1 col-md-3 col-sm-2 col-xs-12 pull-right">
                    <div class="row pull-right">
                        <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12 list-group-item-heading">
                            <label type="button" class="btn btn-outline btn-primary" style="margin-top:10px;" id="clearFilter"><span data-i18n="nav.search">Išvalyti Filtrą</span></label>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div class="ibox-content" style="display:inline-block; width: 100%">
            @{Html.RenderPartial("TagPreviewChart.cshtml", Model.TagChartDto);}
        </div>
    </div>
</div>
@section Scripts {
    <script src="~/lib_bower/bootstrap-datepicker/dist/js/bootstrap-datepicker.min.js"></script>
    <script src="~/lib_bower/bootstrap-datepicker/js/locales/bootstrap-datepicker.lt.js"></script>
    <script type="text/javascript" src="~/lib_bower/moment/moment.js"></script>
    <script src="~/lib/Chart-js/dist/Chart.js"></script>
    <script type="text/javascript">
        $(document).ready(function () {
            window.totalChart = new Chart(document.getElementById("chart_canvas").getContext("2d"),
                    getChartConfig(@Html.Raw(Json.Serialize(Model.TagChartDto.ChartData)),
                    "Signalo stiprumo kitimo grafikas(RSSI)")
            );
            new InitTagPreviewPage({
                    modalUrl: "@Url.Action("OpenErrorItemModal","Errors")",
                    EditTag: "@Url.Action("ChangeTagStatus", "Tags")",
                    Filter: "@Url.Action("GetChartData", "Tags")"
            })




        })

        var InitTagPreviewPage = function (param) {
            TagPreviewPage = {}

            TagPreviewPage.setDataPickerSettings = function (item) {
                item.datepicker({
                    changeMonth: true,
                    changeYear: true,
                    showButtonPanel: true,
                    isRTL: false,
                    format: "yyyy-mm-dd",
                    autoclose: true,
                    language: "lt",
                    minViewMode: "days",
                });
            };

            var startDate = moment('@Model.ChartStartDate.ToString("yyyy-MM-dd HH:mm:ss")').format("YYYY-MM-DD");
            var endDate = moment('@Model.ChartEndDate.ToString("yyyy-MM-dd HH:mm:ss")').format("YYYY-MM-DD");
            TagPreviewPage.setDataPickerSettings($("#datetimepickerNuo"));
            $("#datetimepickerNuo").datepicker("setDate", new Date(startDate));
            $("#datetimepickerNuo").datepicker("setEndDate", new Date(endDate));
            TagPreviewPage.setDataPickerSettings($("#datetimepickerIki"));
            $("#datetimepickerIki").datepicker("setDate", new Date(endDate));
            $("#datetimepickerIki").datepicker("setStartDate", new Date(startDate));


            TagPreviewPage.init = function () {
                TagPreviewPage.startDate = $("#dateFrom").val();
                TagPreviewPage.endDate = $("#dateTo").val();
            };


            TagPreviewPage.get_startDate = function () { return TagPreviewPage.startDate; };
            TagPreviewPage.get_endDate = function () { return TagPreviewPage.endDate; };

            $("#datetimepickerIki").datepicker().on("changeDate", function (ev) {
                let today = new Date(moment().format('YYYY-MM'));
                if (ev.date !== undefined || ev.date != null) {
                    var maxDate = new Date(ev.date.valueOf());
                    $('#datetimepickerNuo').datepicker('setEndDate', maxDate);
                }
                else {
                    $('#dateTo').val(new Date());
                }
                if (TagPreviewPage.get_endDate() === $(ev.currentTarget).find("input").val()) return;
                TagPreviewPage.updateWrapData();
            });
            $("#datetimepickerNuo").datepicker().on("changeDate", function (ev) {
                if (ev.date !== undefined || ev.date != null) {
                    var minDate = new Date(ev.date.valueOf());
                    $('#datetimepickerIki').datepicker('setStartDate', minDate);
                }
                else {
                    $("#datetimepickerNuo").datepicker('update', new Date());
                    $('#dateFrom').val(new Date(moment().format('YYYY-MM')));
                }
                if (TagPreviewPage.get_startDate() === $(ev.currentTarget).find("input").val()) return;
                TagPreviewPage.updateWrapData();
            });


            TagPreviewPage.updateWrapData = function (input) {

                if ($("#dateFrom").val() && $("#dateTo").val()) {
                    TagPreviewPage.startDate = $("#dateFrom").val();
                    TagPreviewPage.endDate = $("#dateTo").val();
                }
                else {
                    TagPreviewPage.startDate = null;
                    TagPreviewPage.endDate = null;
                }

                $.ajax({
                    url: param.Filter,
                    type: "POST",
                    dataType: "text",
                    data: {
                        start: TagPreviewPage.startDate,
                        end: TagPreviewPage.endDate,
                        id: @Model.Id
                    },
                    success: function (data) {
                        var obj = jQuery.parseJSON(data);

                        window.totalChart = new Chart(document.getElementById("chart_canvas").getContext("2d"),
                            getChartConfig(obj.chartData), "Signalo stiprumo kitimo grafikas(RSSI)");
                    },
                    error: function (e) {

                    }
                });
            };

            $("#clearFilter").click(function (e) {
                var now = new Date();
                $("#datetimepickerNuo").datepicker('setDate', new Date(now.getUTCFullYear(), now.getUTCMonth(), now.getUTCDate()).toUTCString());
                $("#dateFrom").val(moment().format('YYYY-MM-DD'));
                $("#datetimepickerIki").datepicker('setDate', new Date().toUTCString());
                $("#dateTo").val(moment().format('YYYY-MM-DD'));

                TagPreviewPage.updateWrapData();
            });

            $("#change_status").click(function (e) {
                $.ajax({
                    url: param.EditTag,
                    type: "POST",
                    dataType: "text",
                    data: {
                        id: @Model.Id
                    },
                    success: function (data) {

                    },
                    error: function (e) {

                    }
                });

                TagPreviewPage.init();
            });
        }

        getChartConfig = function (data, labelText) {
            console.log(data)

            labelsArray = [];
            dataArray = [];

            $.each(data, function (index, value) {
                console.log(value)
                dataArray.push(value.rssi);
                labelsArray.push(value.time);
            });

            var max = Math.max.apply(Math, dataArray) * 1.1;
            var config = {
                type: 'line',
                data: {
                    labels: labelsArray,
                    datasets: [{
                        backgroundColor: 'rgba(137, 20, 87, 1)',
                        borderColor: 'rgba(137, 20, 87, 1)',
                        data: dataArray,
                        fill: false,
                    }]
                },
                options: {
                    responsive: true,
                    title: {
                        display: true,
                        text: labelText
                    },
                    hover: {
                        mode: 'nereast',
                        intersect: true
                    },
                    scales: {
                        yAxes: [{
                            display: true,
                            scaleLabel: {
                                display: true,
                                labelString: 'Dienų skaičius'

                            },
                            ticks: {
                                suggestedMax: parseInt(max, 30)
                            }
                        }]
                    },
                    legend: {
                        display: false
                    }
                }
            }
            return config;
        }
    </script>
}